#!/bin/bash

# http://habilis.net/cronic/
# Cronic v3 - cron job report wrapper
# Copyright 2007-2016 Chuck Houpt. No rights reserved, whatsoever.
# Public Domain CC0: http://creativecommons.org/publicdomain/zero/1.0/

set -eu

TMP=$(mktemp -d)
OUT=$TMP/cronic.out
ERR=$TMP/cronic.err
TRACE=$TMP/cronic.trace

if [[ ! -v PROMETHEUS_METRIC_NAME ]]; then
  PROMETHEUS_METRIC_NAME=<%= node['prometheus']['metrics']['cron'] %>
else
  PROMETHEUS_METRIC_NAME=$PROMETHEUS_METRIC_NAME
fi
if [[ ! -v PROMETHEUS_TAG_NAME ]]; then
  echo "Please set PROMETHEUS_TAG_NAME environment variable. The script will terminate now."
  exit 1
else
  PROMETHEUS_TAG_NAME=$PROMETHEUS_TAG_NAME
fi
NODE_EXPORTER_TEXTFILE_DIRECTORY=<%= node['prometheus']['node_exporter']['textfile_directory'] %>

prometheus () {
  if [ ! -d $NODE_EXPORTER_TEXTFILE_DIRECTORY ]; then
    mkdir -p $NODE_EXPORTER_TEXTFILE_DIRECTORY
  fi
  echo "$PROMETHEUS_METRIC_NAME{name=\"$PROMETHEUS_TAG_NAME\"} $1" > $NODE_EXPORTER_TEXTFILE_DIRECTORY/$PROMETHEUS_TAG_NAME.prom
}

set +e
"$@" >$OUT 2>$TRACE
RESULT=$?
set -e

PATTERN="^${PS4:0:1}\\+${PS4:1}"
if grep -aq "$PATTERN" $TRACE
then
    ! grep -av "$PATTERN" $TRACE > $ERR
else
    ERR=$TRACE
fi

if [ $RESULT -ne 0 -o -s "$ERR" ]
    then
    prometheus 0
    echo "Cronic detected failure or error output for the command:"
    echo "$@"
    echo
    echo "RESULT CODE: $RESULT"
    echo
    echo "ERROR OUTPUT:"
    cat "$ERR"
    echo
    echo "STANDARD OUTPUT:"
    cat "$OUT"
    if [ $TRACE != $ERR ]
    then
        echo
        echo "TRACE-ERROR OUTPUT:"
        cat "$TRACE"
    fi
else
    prometheus 1
fi

rm -rf "$TMP"
